VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TrayBase"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const NIM_ADD As Long = &H0&
Private Const NIM_MODIFY As Long = &H1&
Private Const NIM_DELETE As Long = &H2&
Private Const NIF_MESSAGE As Long = &H1&
Private Const NIF_ICON As Long = &H2&
Private Const NIF_TIP As Long = &H4&
Private Const WM_MOUSEMOVE As Long = &H200&
Private Const WM_LBUTTONUP As Long = &H202&
Private Const WM_LBUTTONDBLCLK As Long = &H203&
Private Const WM_RBUTTONUP As Long = &H205&
Private Const WM_RBUTTONDBLCLK As Long = &H206&
Private Const WM_MBUTTONUP As Long = &H208&
Private Const WM_MBUTTONDBLCLK As Long = &H209&

Private Type NOTIFYICONDATA
  cbSize As Long
  hwnd As Long
  uID As Long
  uFlags As Long
  uCallBackMessage As Long
  hIcon As Long
  szTip As String * 64
End Type

Private Declare Function Shell_NotifyIcon _
  Lib "shell32" Alias "Shell_NotifyIconA" ( _
  ByVal dwMessage As Long, _
  ByRef pNOD As NOTIFYICONDATA _
  ) As Boolean
Private Declare Function GetForegroundWindow _
  Lib "user32" ( _
  ) As Long
Private Declare Function SetForegroundWindow _
  Lib "user32" ( _
  ByVal hwnd As Long _
  ) As Long
Private Declare Function AttachThreadInput _
  Lib "user32" ( _
  ByVal idAttach As Long, _
  ByVal idAttachTo As Long, _
  ByVal fAttach As Long _
  ) As Long
Private Declare Function GetWindowThreadProcessId _
  Lib "user32" ( _
  ByVal hwnd As Long, _
  lpdwProcessId As Long _
  ) As Long

Private WithEvents mvarTrayForm As Form
Attribute mvarTrayForm.VB_VarHelpID = -1
Private NID As NOTIFYICONDATA
Private mvarTrayMenu As Menu
Private mvarToolTip As String
Private mvarhIcon As Long
Private mvarRestoreMode As Long
Private mvarActive As Long
Private WindowState As Long

Public Event Click(ByVal Button As Integer, ByVal Shift As Integer)
Public Event DblClick(ByVal Button As Single, ByVal Shift As Integer)

Public Property Let hIcon(ByVal vData As Long)
  If mvarhIcon <> vData Then
    mvarhIcon = vData
    If mvarActive Then ModifyTray
  End If
End Property

Public Property Get hIcon() As Long
  hIcon = mvarhIcon
End Property

Public Property Let ToolTip(ByVal vData As String)
  If mvarToolTip <> vData Then
    mvarToolTip = vData
    If mvarActive Then ModifyTray
  End If
End Property

Public Property Get ToolTip() As String
  ToolTip = mvarToolTip
End Property

Public Property Set TrayMenu(ByVal vData As Object)
  Set mvarTrayMenu = vData
End Property

Public Property Get TrayMenu() As Object
  Set TrayMenu = mvarTrayMenu
End Property

Public Property Set TrayForm(ByVal vData As Object)
  If mvarTrayForm Is vData Then Exit Property
  If Not mvarTrayForm Is Nothing Then TerminateTray
  Set mvarTrayForm = vData
  If mvarActive And Not (vData Is Nothing) Then InitializeTray
  
End Property

Public Property Get TrayForm() As Object
  Set TrayForm = mvarTrayForm
End Property

Public Property Let Active(ByVal New_Active As Boolean)
  If New_Active = mvarActive Then Exit Property
  If mvarTrayForm Is Nothing Then mvarActive = False: Exit Property
  If New_Active Then
    InitializeTray
    WindowState = mvarTrayForm.WindowState
  Else
    TerminateTray
  End If
  mvarActive = New_Active
End Property

Public Property Get Active() As Boolean
  Active = mvarActive
End Property

Private Function FillNID() As Boolean
Dim lngFlags As Long
  If mvarTrayForm Is Nothing Then Exit Function
  lngFlags = NIF_MESSAGE
  If mvarhIcon <> 0 Then lngFlags = lngFlags Or NIF_ICON
  If mvarToolTip <> vbNullString Then lngFlags = lngFlags Or NIF_TIP
  If Len(mvarToolTip) > 63 Then mvarToolTip = Left$(mvarToolTip, 63)
  With NID
    .cbSize = Len(NID)
    .hwnd = mvarTrayForm.hwnd
    .uID = 0
    .uFlags = lngFlags
    .uCallBackMessage = WM_MOUSEMOVE
    .hIcon = mvarhIcon
    .szTip = mvarToolTip & vbNullChar
  End With
  FillNID = True
End Function

Private Function InitializeTray() As Boolean
  If Not FillNID() Then Exit Function
  InitializeTray = Shell_NotifyIcon(NIM_ADD, NID) <> 0
End Function

Private Function ModifyTray() As Boolean
  If Not mvarActive Then Exit Function
  If Not FillNID() Then Exit Function
  ModifyTray = Shell_NotifyIcon(NIM_MODIFY, NID) <> 0
End Function

Private Function TerminateTray() As Boolean
  TerminateTray = Shell_NotifyIcon(NIM_DELETE, NID) <> 0
End Function

Private Sub Class_Terminate()
  If mvarActive Then TerminateTray
  Set mvarTrayMenu = Nothing
  Set mvarTrayForm = Nothing
End Sub

Private Sub mvarTrayForm_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim uMsg As Long, uID As Long
  If Not mvarActive Then Exit Sub
  uMsg = mvarTrayForm.ScaleX(X, mvarTrayForm.ScaleMode, vbPixels)
  Select Case uMsg
    Case WM_LBUTTONUP
      RaiseEvent Click(vbLeftButton, Shift)
    Case WM_MBUTTONUP
      RaiseEvent Click(vbMiddleButton, Shift)
    Case WM_RBUTTONUP
      RaiseEvent Click(vbRightButton, Shift)
      If Not mvarTrayMenu Is Nothing And mvarActive Then
        SetForegroundWindowEx mvarTrayForm.hwnd
        mvarTrayForm.PopupMenu mvarTrayMenu
      End If
  End Select
End Sub

Private Sub mvarTrayForm_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  If Cancel = 0 Then Set mvarTrayForm = Nothing
End Sub

Private Sub mvarTrayForm_Resize()
  If Not mvarActive Then Exit Sub
  If mvarTrayForm.WindowState = vbMinimized Then
    mvarTrayForm.Hide
  Else
    mvarTrayForm.Show
    WindowState = mvarTrayForm.WindowState
  End If
End Sub

Private Sub mvarTrayForm_Unload(Cancel As Integer)
  Class_Terminate
End Sub

Private Sub SetForegroundWindowEx(ByVal hWndWindow As Long)
Dim lThreadForeWin As Long, lThreadMyWin As Long
   If hWndWindow <> GetForegroundWindow() Then
      lThreadForeWin = GetWindowThreadProcessId(GetForegroundWindow, ByVal 0&)
      lThreadMyWin = GetWindowThreadProcessId(hWndWindow, ByVal 0&)
      If lThreadForeWin <> lThreadMyWin Then
         AttachThreadInput lThreadForeWin, lThreadMyWin, True
         SetForegroundWindow hWndWindow
         AttachThreadInput lThreadForeWin, lThreadMyWin, False
      Else
         SetForegroundWindow hWndWindow
      End If
   End If
End Sub


